---
--- Run as defined rw user on database, on which were performed scripts with lower number
--- psql -U cdnskey_processor -d cdnskey_processor -f 0003_enum_tables_to_enum_type.sql
---

CREATE TYPE SCAN_TYPE AS ENUM
(
    'insecure',
    'secure'
);

ALTER TABLE scan_job
 ADD COLUMN scan_type SCAN_TYPE;

UPDATE scan_job AS j
   SET scan_type =
       (SELECT name::SCAN_TYPE
          FROM enum_scan_type AS t
         WHERE t.id = j.scan_type_id
       );

DROP INDEX scan_job_scan_type_id_idx;
CREATE INDEX IF NOT EXISTS scan_job_scan_type_id_idx ON scan_job(scan_type);

ALTER TABLE scan_job
 DROP CONSTRAINT scan_job_check,
  ADD CONSTRAINT scan_job_check
                 CHECK (nameserver IS NOT NULL
                    OR scan_type = 'secure'::SCAN_TYPE),
ALTER COLUMN scan_type SET NOT NULL,
 DROP COLUMN scan_type_id;


CREATE TYPE CDNSKEY_STATUS AS ENUM
(
    'insecure',
    'insecure-empty',
    'unresolved',
    'secure',
    'secure-empty',
    'untrustworthy',
    'unknown',
    'unresolved-ip'
);

ALTER TABLE scan_result
 ADD COLUMN cdnskey_status CDNSKEY_STATUS;

UPDATE scan_result AS r
   SET cdnskey_status =
       (SELECT name::CDNSKEY_STATUS
          FROM enum_cdnskey_status AS s
         WHERE s.id = r.cdnskey_status_id
       );

ALTER TABLE scan_result
ALTER COLUMN cdnskey_status
         SET NOT NULL,
 DROP COLUMN cdnskey_status_id;
