---
--- Run as defined rw user on newly created database
--- psql -U cdnskey_processor -d cdnskey_processor -f 0008_split_scan_batch_table.sql
---

ALTER TABLE scan_batch
  RENAME TO scan_batch_progress;

CREATE TABLE IF NOT EXISTS scan_batch
(
    id BIGINT PRIMARY KEY NOT NULL
);

INSERT INTO scan_batch
       SELECT DISTINCT id
         FROM scan_batch_progress
        ORDER BY id;

ALTER TABLE scan_batch
      ALTER COLUMN id
            ADD GENERATED ALWAYS AS IDENTITY;

SELECT SETVAL(PG_GET_SERIAL_SEQUENCE('scan_batch', 'id'), COALESCE(MAX(id), 1))
  FROM scan_batch;

ALTER TABLE scan_batch_progress
     RENAME COLUMN id TO scan_batch_id;

ALTER TABLE scan_batch_progress
        ADD CONSTRAINT scan_batch_progress_scan_batch_id_fkey
            FOREIGN KEY (scan_batch_id) REFERENCES scan_batch(id) ON DELETE CASCADE,
        ADD COLUMN id BIGINT GENERATED ALWAYS AS IDENTITY PRIMARY KEY NOT NULL;

ALTER TABLE scan_job
        ADD CONSTRAINT scan_job_scan_batch_id_fkey
            FOREIGN KEY (scan_batch_id) REFERENCES scan_batch(id) ON DELETE CASCADE;

DROP VIEW IF EXISTS scan_batch_by_scan_queue;
DROP VIEW IF EXISTS scan_queue_progress;
CREATE VIEW scan_queue_progress
AS
    SELECT DISTINCT scan_queue_id, b.id AS scan_batch_id, bp.scan_batch_id IS NOT NULL AS has_progress,
                    bp.worker_id, bp.sent_at, bp.start_at, bp.finished_at, scan_type
      FROM scan_batch AS b
           LEFT OUTER JOIN scan_batch_progress AS bp
              ON b.id = bp.scan_batch_id
           INNER JOIN scan_job AS j
              ON b.id = j.scan_batch_id
     ORDER BY scan_queue_id, b.id, worker_id;
