/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef API_HH_35B4C651830CAFAEB499CCF74383B535//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define API_HH_35B4C651830CAFAEB499CCF74383B535

#include "src/cfg/database.hh"
#include "src/cfg/log.hh"

#include <chrono>
#include <string>

namespace CdnskeyProcessor {
namespace Cfg {

struct Api
{
    struct Help {};
    std::string grpc_address;
    struct Report
    {
        bool disabled;
    } report;
    struct Supervisor
    {
        bool disabled;
        std::size_t batch_size;
        std::chrono::seconds max_scan_period;
        std::chrono::seconds min_period_fixed_cdnskey;
    } supervisor;
};

Api get_cfg(int argc, char** argv, void(*)(const Log&) = nullptr, void(*)(const Database&) = nullptr);

}//namespace CdnskeyProcessor::Cfg
}//namespace CdnskeyProcessor

#endif//API_HH_35B4C651830CAFAEB499CCF74383B535
