/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DATABASE_HH_81693B72B0A33EC45F06BE4DA0BBFA10//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define DATABASE_HH_81693B72B0A33EC45F06BE4DA0BBFA10

#include <boost/asio/ip/address.hpp>
#include <boost/optional.hpp>
#include <boost/program_options.hpp>

#include <chrono>
#include <cstdint>
#include <string>

namespace CdnskeyProcessor {
namespace Cfg {

struct Database
{
    std::string host;
    boost::optional<boost::asio::ip::address> host_addr;
    boost::optional<std::uint16_t> port;
    std::string db_name;
    std::string user;
    std::string password;
    boost::optional<std::chrono::seconds> connect_timeout;
};

boost::program_options::options_description get_options(Database&);

}//namespace CdnskeyProcessor::Cfg
}//namespace CdnskeyProcessor

#endif//DATABASE_HH_81693B72B0A33EC45F06BE4DA0BBFA10
