/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef MASTER_HH_F097E4FFE32C04D92F1F273254A9F9DE//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define MASTER_HH_F097E4FFE32C04D92F1F273254A9F9DE

#include "src/cfg/database.hh"
#include "src/cfg/log.hh"

#include <boost/optional.hpp>

#include <cstdint>
#include <string>

namespace CdnskeyProcessor {
namespace Cfg {

struct Master
{
    struct Help {};
    struct Amqp
    {
        std::uint16_t prefetch_count;
        struct Broker
        {
            std::string hostname;
            std::uint16_t port;
            std::string vhost;
            std::string username;
            std::string password;
        } broker;
        struct Exchange
        {
            std::string insecure_fanout;
            std::string secure;
            std::string response;
        } exchange;
        struct Queue
        {
            std::string results;
            std::string insecure_prefix;
            std::string secure;
        } queue;
    } amqp;
};

Master get_cfg(int argc, char** argv, void(*)(const Log&) = nullptr, void(*)(const Database&) = nullptr);

}//namespace CdnskeyProcessor::Cfg
}//namespace CdnskeyProcessor

#endif//MASTER_HH_F097E4FFE32C04D92F1F273254A9F9DE
