/*
 * Copyright (C) 2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef VALIDATOR_HH_C3767532C6B913AF87730BBC437D4B45//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define VALIDATOR_HH_C3767532C6B913AF87730BBC437D4B45

#include "src/cfg/log.hh"

#include <boost/any.hpp>
#include <boost/asio/ip/address.hpp>

#include <chrono>
#include <iosfwd>
#include <string>
#include <vector>

namespace std {
namespace chrono {

void validate(boost::any& dst, const std::vector<std::string>& values, seconds*, int);

std::ostream& operator<<(std::ostream& out, const seconds& value);

}//std::chrono
}//std

namespace boost {
namespace asio {
namespace ip {
    
void validate(any& dst, const std::vector<std::string>& options, address*, int);

}//namespace boost::asio::ip
}//namespace boost::asio
}//namespace boost

namespace CdnskeyProcessor {
namespace Cfg {

void validate(boost::any& dst, const std::vector<std::string>& options, Log::Level*, int);

}//namespace CdnskeyProcessor::Cfg
}//namespace CdnskeyProcessor

#endif//VALIDATOR_HH_C3767532C6B913AF87730BBC437D4B45
