/*
 * Copyright (C) 2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DOMAIN_CDNSKEY_HH_0A5B86D2690B6A03831E8A2016757BC4//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define DOMAIN_CDNSKEY_HH_0A5B86D2690B6A03831E8A2016757BC4

#include "src/scan_task.hh"

#include <vector>

namespace CdnskeyProcessor {

struct DomainCdnskey
{
    DomainFqdn domain_fqdn;
    DomainUid domain_uid;
    CdnskeyFlags flags;
    CdnskeyProto proto;
    CdnskeyAlg alg;
    CdnskeyPublicKey public_key;
};

using AcceptableCdnskeys = std::vector<DomainCdnskey>;

}//namespace CdnskeyProcessor

#endif//DOMAIN_CDNSKEY_HH_0A5B86D2690B6A03831E8A2016757BC4
