/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/internal/amqp/bind_queue.hh"

using namespace CdnskeyProcessor::Internal::Amqp;

AMQP::Deferred& CdnskeyProcessor::Internal::Amqp::bind_queue(
        AMQP::TcpChannel& channel,
        const std::string& queue,
        const Recipient& recipient,
        const AMQP::Table& arguments)
{
    return channel.bindQueue(recipient.exchange_name, queue, recipient.routing_key, arguments);
}
