/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BIND_QUEUE_HH_7260F146753EE7A0215BACD98179A34C
#define BIND_QUEUE_HH_7260F146753EE7A0215BACD98179A34C

#include "src/internal/amqp/exchange.hh"

#include <amqpcpp.h>
#include <amqpcpp/libboostasio.h>

#include <string>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

AMQP::Deferred& bind_queue(
        AMQP::TcpChannel& channel,
        const std::string& queue,
        const Recipient& recipient,
        const AMQP::Table& arguments);

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

#endif//BIND_QUEUE_HH_7260F146753EE7A0215BACD98179A34C
