/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BOOST_ASIO_HANDLER_HH_60B96D0E5504DB3846E2176C1540CC74
#define BOOST_ASIO_HANDLER_HH_60B96D0E5504DB3846E2176C1540CC74

#include <amqpcpp.h>
#include <amqpcpp/libboostasio.h>

#include <boost/asio/io_context.hpp>

#include <functional>
#include <memory>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

std::unique_ptr<AMQP::TcpHandler> make_boost_asio_handler(
        boost::asio::io_context& service,
        std::function<void(AMQP::TcpConnection*)> on_ready = nullptr,
        std::function<void(AMQP::TcpConnection*, const char*)> on_error = nullptr,
        std::function<void(AMQP::TcpConnection*)> on_lost = nullptr);

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

#endif//BOOST_ASIO_HANDLER_HH_60B96D0E5504DB3846E2176C1540CC74
