/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef PUBLISH_HH_881D8DDB93DEF9452C1B533E91BABCDF
#define PUBLISH_HH_881D8DDB93DEF9452C1B533E91BABCDF

#include "src/internal/amqp/exchange.hh"
#include "src/internal/amqp/queue.hh"

#include <amqpcpp.h>
#include <amqpcpp/libboostasio.h>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

bool publish(
        AMQP::TcpChannel& channel,
        const Recipient& recipient,
        const AMQP::Envelope& envelope,
        int flags);

template <typename T>
AMQP::DeferredPublish& publish(
        AMQP::Reliable<T>& reliable_channel,
        const Recipient& recipient,
        const AMQP::Envelope& envelope,
        int flags)
{
    return reliable_channel.publish(recipient.exchange_name, recipient.routing_key, envelope, flags);
}

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

#endif//PUBLISH_HH_881D8DDB93DEF9452C1B533E91BABCDF
