/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/internal/amqp/queue.hh"

#include <iostream>
#include <utility>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

Queue::Queue(std::string name)
    : queue_name_{std::move(name)}
{ }

Queue::operator const std::string&() const noexcept
{
    return queue_name_;
}

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

using namespace CdnskeyProcessor::Internal::Amqp;

std::ostream& CdnskeyProcessor::Internal::Amqp::operator<<(std::ostream& out, const Queue& queue)
{
    return out << queue.queue_name_;
}
