/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef RELIABLE_TCP_CHANNEL_HH_4AB44C8909D558888C4DBF8E62CACD5F
#define RELIABLE_TCP_CHANNEL_HH_4AB44C8909D558888C4DBF8E62CACD5F

#include <amqpcpp.h>
#include <amqpcpp/libboostasio.h>

#include <memory>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

class ReliableTcpChannel
{
public:
    explicit ReliableTcpChannel(std::unique_ptr<AMQP::TcpChannel> channel);
    ReliableTcpChannel() = delete;
    ReliableTcpChannel(const ReliableTcpChannel&) = delete;
    ReliableTcpChannel(ReliableTcpChannel&&) = delete;
    ReliableTcpChannel& operator=(const ReliableTcpChannel&) = delete;
    ReliableTcpChannel& operator=(ReliableTcpChannel&&) = delete;

    AMQP::Reliable<>& operator*();
private:
    std::unique_ptr<AMQP::TcpChannel> channel_;
    AMQP::Reliable<> reliable_;
};

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

#endif//RELIABLE_TCP_CHANNEL_HH_4AB44C8909D558888C4DBF8E62CACD5F
