/*
 * Copyright (C) 2023-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef TCP_CONNECTION_HH_58FBCEADEC2C3CAEB2A413AB121C519C
#define TCP_CONNECTION_HH_58FBCEADEC2C3CAEB2A413AB121C519C

#include <amqpcpp.h>
#include <amqpcpp/libboostasio.h>

#include <memory>

namespace CdnskeyProcessor {
namespace Internal {
namespace Amqp {

std::unique_ptr<AMQP::TcpConnection> make_tcp_connection(
        std::unique_ptr<AMQP::TcpHandler> io_handler,
        const AMQP::Address& address);

}//namespace CdnskeyProcessor::Internal::Amqp
}//namespace CdnskeyProcessor::Internal
}//namespace CdnskeyProcessor

#endif//TCP_CONNECTION_HH_58FBCEADEC2C3CAEB2A413AB121C519C
