/*
 * Copyright (C) 2020-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SCAN_RESULT_HH_0BD1FBAC7EA6ACBA33623C197C641F10
#define SCAN_RESULT_HH_0BD1FBAC7EA6ACBA33623C197C641F10

#include "src/scan_task.hh"

#include <vector>

namespace CdnskeyProcessor {

struct ScanResult
{
    ScanJobId scan_job_id;
    Timestamp scan_at;
    IpAddress::Optional nameserver_ip;
    Cdnskey cdnskey;
    Nameserver::Optional nameserver;
    bool is_successful() const;
};

struct ScanResultCollection
{
    using ScanResults = std::vector<ScanResult>;
    ScanBatchId scan_batch_id;
    WorkerName worker_name;
    Timestamp sent_at;
    Timestamp::Optional started_at;
    Timestamp::Optional finished_at;
    ScanResults scan_results;
};
std::string serialize(const ScanResultCollection&);

template <>
ScanResultCollection deserialize(const char*, std::size_t);

} // namespace CdnskeyProcessor

#endif//SCAN_RESULT_HH_0BD1FBAC7EA6ACBA33623C197C641F10
