/*
 * Copyright (C) 2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef RAW_SCAN_RESULTS_HH_6D93D1882456BBFA070CC6B43A1769FB//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define RAW_SCAN_RESULTS_HH_6D93D1882456BBFA070CC6B43A1769FB

#include "src/scan_task.hh"

#include <vector>

namespace CdnskeyProcessor {
namespace Report {

struct RawScanResult
{
    WorkerName::Optional worker_name;
    Timestamp::Optional scan_at;
    Nameserver::Optional nameserver;
    IpAddress::Optional nameserver_ip;
    Cdnskey cdnskey;
};

using RawScanResultsReply = std::vector<RawScanResult>;

}//namespace CdnskeyProcessor::Report
}//namespace CdnskeyProcessor

#endif//RAW_SCAN_RESULTS_HH_6D93D1882456BBFA070CC6B43A1769FB
