/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef __CONF__7CFF2B910278F33AC64C9F985807506B
#define __CONF__7CFF2B910278F33AC64C9F985807506B

#include "result_importer/conf.hh"

#include <src/conf/setup.hh>

namespace CdnskeyProcessor {
namespace Test {

::CdnskeyProcessor::Conf::Conf parse_conf(std::ifstream& _file)
{
    auto database_conf = std::make_shared<Conf::Section::Database>();
    auto database_options = get_database_options(database_conf);

    const auto vm = ::CdnskeyProcessor::Conf::fill_conf(_file, database_options);
    database_conf->fill(vm);

    ::CdnskeyProcessor::Conf::Conf conf;
    conf.set(database_conf);
    return conf;
}

} // namespace CdnskeyProcessor::Test
} // namespace CdnskeyProcessor

#endif
