/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef __CONTEXT__E2608BE0D7CD27049D490BCA89CC2045
#define __CONTEXT__E2608BE0D7CD27049D490BCA89CC2045

#include <initializer_list>
#include <string>

namespace CdnskeyProcessor {
namespace Test {
namespace Log {

class SetContext
{
public:
    explicit SetContext(std::initializer_list<std::string> _context_hierarchy);
    void add(std::initializer_list<std::string> _context_hierarchy);

    ~SetContext();

    SetContext() = delete;
    SetContext(const SetContext&) = delete;
    SetContext(SetContext&&) = delete;
    SetContext& operator=(const SetContext&) = delete;
    SetContext& operator=(SetContext&&) = delete;

private:
    std::string previous_context_;
};

const std::string& get_context();

} // namespace CdnskeyProcessor::Test::Log
} // namespace CdnskeyProcessor::Test
} // namespace CdnskeyProcessor

#endif
