/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "import_results_from_file/log/setup.hh"

#include <liblog/liblog.hh>
#include <liblog/log.hh>

namespace CdnskeyProcessor {
namespace Test {
namespace Log {

void setup(bool debug)
{
    constexpr LibLog::ThreadMode threading = LibLog::ThreadMode::multi_threaded; // global, compile-time parameter
    auto liblog_log_config = LibLog::LogConfig();
    if (debug)
    {
        liblog_log_config.add_sink_config(LibLog::Sink::ConsoleSinkConfig()
                .set_level(LibLog::Level::debug));
    }
    LibLog::Log::start<threading>(liblog_log_config);
    const std::string pattern = "%v -- {%s:%#}";
    spdlog::set_pattern(pattern);
}

} // namespace CdnskeyProcessor::Test::Log
} // namespace CdnskeyProcessor::Test
} // namespace CdnskeyProcessor
