/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef __STORAGE__5BEFA0EA1503F52850832C784D9D865D
#define __STORAGE__5BEFA0EA1503F52850832C784D9D865D

#include "result_importer/scan_queue.hh"

#include <libpg/dsn.hh>

namespace CdnskeyProcessor {
namespace Test {
namespace Storage {

struct ImportedScanQueueMissing : public std::exception
{
    const char* what() const noexcept override
    {
        return "imported scan queue missing";
    }
};

struct ImportedScanBatchesAreEmpty : public std::exception
{
    const char* what() const noexcept override
    {
        return "imported scan batches are empty. Perhaps, worker table is empty?";
    }
};

struct DatabaseError : public std::runtime_error
{
    using std::runtime_error::runtime_error;
};

void import_scan_tasks(const LibPg::Dsn&, const ScanQueues&);
void import_scan_results(const LibPg::Dsn&, ScanQueues&);

} // namespace CdnskeyProcessor::Test::Storage
} // namespace CdnskeyProcessor::Test
} // namespace CdnskeyProcessor

#endif
